<template>
  <el-dialog
    v-dialogDrag
    :title="'2025年'+title+'改革试点推进情况'"
    :visible="visible"
    :before-close="handleClose"
    :close-on-click-modal="false"
    :append-to-body="true"
    v-if="visible"
    width="50%"
    :class="[reqLoading ? 'dialog-box' : '']"
  >
    <div
      v-loading="reqLoading"
      element-loading-text="加载中..."
      element-loading-spinner="el-icon-loading"
      element-loading-background="rgba(255, 255, 255, 1)"
    >
        <el-alert
          title="请先添加正在推进数量，在添加页面填报“验收数量”和“新争取试点数量”内容！"
          type="warning"
          :closable="false">
        </el-alert>
        <div class="dialog-flex">
          <div class="dialog-title">
            <div class="title-style">正在推进数量：</div>
            <div class="title-number">{{projectNum}}</div>
          </div>
          <el-link icon="el-icon-plus" type="primary" @click="projectChange()" :underline="false" class="cloumn-btn">
            添加
          </el-link>
        </div>
        <div class="dialog-flex">
          <div class="dialog-title">
            <div class="title-style">完成验收数量：</div>
            <div class="title-number">{{researchNum}}</div>
          </div>
        </div>
        <div class="dialog-flex">
          <div class="dialog-title">
            <div class="title-style">新争取试点数量：</div>
            <div class="title-number">{{introducedNum}}</div>
          </div>
        </div>
    </div>
    <div
      slot="footer"
      class="dialog-footer"
      :style="reqLoading ? 'position: relative;z-index: -1;' : ''"
    >
      <el-button type="primary" @click="ensureChange" v-if="isDetails">确定</el-button>
      <el-button @click="handleClose" v-if="isDetails">取消</el-button>
    </div>

    <add-pilot ref="addPilot" @confirm="onConfirm"></add-pilot>
  </el-dialog>
</template>

<script>
import { TableMixin } from '@/mixins/tableMixin'
import addPilot from './addPilot.vue'
export default {
  name: 'AddFormDialog',
  mixins: [TableMixin],
  components: {addPilot},
  props:{
  },
  data() {
    return {
      visible: false,
      reqLoading: false,
      activeNames: '',
      title:'',
      projectNum:0,
      researchNum:0,
      introducedNum:0,
      dataList:{
        projectList:[],
        researchList:[],
        introducedList:[],
        historyProjectList:[],
        historyResearchList:[],
        histotyIntroducedList:[]
      },
      historyDataList:{
        historyProjectList:[],
        historyResearchList:[],
        histotyIntroducedList:[]
      },
      isDetails:false,
      isEditHistory:'',
      details:{}
    }
  },
  created() {
  },
  methods: {
    upDate(title,data,isDetails,historyData,details){
      this.details = details;
      this.isDetails = isDetails !== '详情';
      this.isEditHistory = isDetails
      this.projectNum = 0
      this.researchNum = 0
      this.introducedNum = 0
      this.dataList = {
        projectList:[],
        researchList:[],
        introducedList:[],
        historyProjectList:[],
        historyResearchList:[],
        histotyIntroducedList:[]
      }
      this.historyDataList = {
        historyProjectList:[],
        historyResearchList:[],
        histotyIntroducedList:[]
      }
      this.title = title
      this.visible = true

      //回显 将一个数组转为三个数组
      if(data.length>0){
        this.dataList.projectList = data.map(item => ({
          projectName: item.projectName,
          isFinish: item.isFinish,
          isPlan: item.isPlan,
          isHistory: item.isHistory,
          key:item.id?item.id:item.key,
          finishExit:item.finishExit,
          planExit:item.planExit,
          hisIsFinish:item.hisIsFinish,
          hisIsPlan:item.hisIsPlan,
        }));
        data.forEach(item => {
          if (item.isFinish === "1") {
            this.dataList.researchList.push({
              key:item.id?item.id:item.key,
              projectName: item.projectName,
              isHistory: item.isHistory,
              reportFileList: item.reportFileList?item.reportFileList:[],
              reportFileIsClassified:item.reportFileIsClassified,
            });
          }
          if (item.isPlan === "1") {
            this.dataList.introducedList.push({
              key:item.id?item.id:item.key,
              projectName: item.projectName,
              isHistory: item.isHistory,
              proofFileList: item.proofFileList?item.proofFileList:[],
              proofFileIsClassified:item.proofFileIsClassified,
            });
          }
        });
      }

      //回显 将一个数组转为三个数组   (历史数据)
      if(historyData.length>0){
        this.historyDataList.historyProjectList = historyData.map(item => ({
          projectName: item.projectName,
          isFinish: item.isFinish,
          isPlan: item.isPlan,
          isHistory: item.isHistory,
          key:item.id?item.id:item.key,
          finishExit:item.finishExit,
          planExit:item.planExit,
          hisIsFinish:item.hisIsFinish,
          hisIsPlan:item.hisIsPlan,
        }));
        historyData.forEach(item => {
          if(item.isFinish === "1" && item.isNowDatar === '1'){
            this.dataList.researchList.push({
              key:item.id?item.id:item.key,
              projectName: item.projectName,
              isHistory: item.isHistory,
              reportFileList: item.reportFileList?item.reportFileList:[],
              reportFileIsClassified:item.reportFileIsClassified,
              isNowDatar:'1',
              finishExit:item.finishExit,
              index:item.index,
            });
          }

          if((item.isFinish === "1" && item.isNowDatar === '0') || (item.isFinish === "1" && !item.isNowDatar)){
            this.historyDataList.historyResearchList.push({
              key:item.id?item.id:item.key,
              projectName: item.projectName,
              isHistory: item.isHistory,
              reportFileList: item.reportFileList?item.reportFileList:[],
              reportFileIsClassified:item.reportFileIsClassified,
              isNowDatar:'0',
              finishExit:item.finishExit,
            });
          }

          if(item.isPlan === "1" && item.isNowDatas === '1'){
            this.dataList.introducedList.push({
              key:item.id?item.id:item.key,
              projectName: item.projectName,
              planNumber: item.planNumber,
              planName: item.planName,
              isHistory: item.isHistory,
              proofFileList: item.proofFileList?item.proofFileList:[],
              planFileIsClassified:item.planFileIsClassified,
              isNowDatas:'1',
              planExit:item.planExit,
              index:item.index,
            });
          }

          if((item.isPlan === "1" && item.isNowDatas === '0') || item.isPlan === "1" && !item.isNowDatas){
            this.historyDataList.histotyIntroducedList.push({
              key:item.id?item.id:item.key,
              projectName: item.projectName,
              planNumber: item.planNumber,
              planName: item.planName,
              isHistory: item.isHistory,
              proofFileList: item.proofFileList?item.proofFileList:[],
              planFileIsClassified:item.planFileIsClassified,
              isNowDatas:'0',
              planExit:item.planExit,
            });
          }

        });
      }
      this.projectNum = (this.dataList.projectList.length - this.dataList.researchList.length) + (this.historyDataList.historyProjectList.length - this.historyDataList.historyResearchList.length)
      this.researchNum = this.dataList.researchList.length + this.historyDataList.historyResearchList.length
      this.introducedNum = this.dataList.introducedList.length + this.historyDataList.histotyIntroducedList.length
    },
    handleClose(){
      this.visible = false
      this.dataList = {
        projectList:[],
        researchList:[],
        introducedList:[],
        historyProjectList:[],
        historyResearchList:[],
        histotyIntroducedList:[]
      }
      this.historyDataList = {
        historyProjectList:[],
        historyResearchList:[],
        histotyIntroducedList:[]
      }
    },
    projectChange(){
      this.$refs.addPilot.upDate(this.title,this.dataList,this.isDetails,this.historyDataList,this.isEditHistory,this.details)
    },
    onConfirm(data){
      this.projectNum = (data.projectList.length - data.researchList.length) + (data.historyProjectList.length - data.historyResearchList.length)
      this.researchNum = data.researchList.length + data.historyResearchList.length
      this.introducedNum = data.introducedList.length + data.histotyIntroducedList.length
      this.historyDataList.historyProjectList = data.historyProjectList
      this.historyDataList.historyResearchList = data.historyResearchList
      this.historyDataList.histotyIntroducedList = data.histotyIntroducedList
      this.dataList = data
    },
    ensureChange(){
      this.visible = false
      this.dataList.historyProjectList = this.historyDataList.historyProjectList
      this.dataList.historyResearchList = this.historyDataList.historyResearchList
      this.dataList.histotyIntroducedList = this.historyDataList.histotyIntroducedList
      this.$emit('confirm',this.dataList,this.title)
    }
  },
}
</script>

<style lang="scss" scoped>
@import '~@/assets/css/element-variables.scss';
/deep/ .file_name{
  height: auto !important;
}

/deep/ .el-dialog__body {
  padding: 15px 20px;
}

.cloumn-btn {
  border: 1px solid #2761ff;
  padding: 3px 10px;
  border-radius: 5px;
  margin-left: 4px;
  margin-bottom: 4px;
  margin-top: 14px;
  &:nth-child(1) {
    margin-right: 5px;
  }

  &:nth-child(1):hover {
    background-color: #2761ff;
    color: #fff;
  }

  &:nth-child(2):hover {
    background-color: #2761ff;
    color: #fff;
    border-color: #2761ff;
  }

  /deep/ i,
  span {
    font-size: 14px;
  }
}

.dialog-flex{
  display: flex;
  align-items: center;
}
.dialog-title{
  display: flex;
  align-items: center;
  line-height: 3;
  margin:10px 30px 0 20px;
}
.title-number{
  font-size: 16px;
}
.title-style{
  font-size: 16px;
  font-weight: 700;
}
.cloumn-btn {
  border: 1px solid #2761ff;
  padding: 3px 10px;
  border-radius: 5px;
  margin-left: 4px;
  margin-bottom: 4px;
  &:nth-child(1) {
    margin-right: 5px;
  }

  &:nth-child(1):hover {
    background-color: #2761ff;
    color: #fff;
  }

  &:nth-child(2):hover {
    background-color: #2761ff;
    color: #fff;
    border-color: #2761ff;
  }

  /deep/ i,
  span {
    font-size: 14px;
  }
}
</style>
